# coding: utf8
from sinops.models import Operation
import objectpack

from . import ui


class SinopsPack(objectpack.ObjectPack):

    u"""Реестр ЮР действий."""

    title = u'ЮР действия'
    model = Operation
    list_window = ui.SOListWin
    edit_window = ui.SOEditWin
    filter_engine_clz = objectpack.filters.ColumnFilterEngine

    list_sort_order = [
        '-created',
        'operation_type__code',
    ]

    columns = [
        {
            'header': u'Код',
            'data_index': 'operation_type.code',
            'width': 1,
            'sortable': True,
            'filter': objectpack.filters.FilterByField(
                model, 'operation_type.code'
            )
        },
        {
            'header': u'Описание',
            'data_index': 'operation_type.description',
            'width': 3,
            'sortable': True,
            'filter': objectpack.filters.FilterByField(
                model, 'operation_type.description'
            )
        },
        {
            'header': u'Урл',
            'data_index': 'request_path',
            'width': 3,
            'sortable': True,
            'filter': objectpack.filters.FilterByField(
                model, 'request_path'
            )
        },
        {
            'header': u'Время выполнения операции',
            'data_index': 'created',
            'width': 3,
            'sortable': True,
            'filter': objectpack.filters.FilterByField(
                model, 'created'
            )
        },
        {
            'header': u'Владелец',
            'data_index': 'certificate.subject_name',
            'width': 4,
            'sortable': True,
            'filter': objectpack.filters.FilterByField(
                model, 'certificate.subject_name'
            )
        },
    ]

    def prepare_row(self, obj, request, context):
        obj = super(SinopsPack, self).prepare_row(obj, request, context)
        return obj

    def extend_menu(self, menu):
        return menu.administry(
            menu.Item(self.title, self.list_window_action),
        )
